import java.util.*;
import java.io.*;

class TypyTestu {
  public static final boolean DEBUG = false;   // pro ladeni
  public static int POCET_PRVKU = 200000;

  private static Integer[] pole;

  private Collection col;

  static void pripravaInicializacnihoPole() {
    pole = new Integer[POCET_PRVKU];
    for (int i = 0;  i < POCET_PRVKU;  i++) {
      pole[i] = new Integer(i);
    }
    if (DEBUG == true)
      System.out.println("Pole pred: " + Arrays.asList(pole)); 
    List l = Arrays.asList(pole);
//    Collections.shuffle(l);    // nemichat, aby mel kazdy beh stejne podminky
    if (DEBUG == true)
      System.out.println("List:      " + l);
    pole = (Integer[]) l.toArray(new Integer[0]);
    if (DEBUG == true)
      System.out.println("Pole po:   " + Arrays.asList(pole)); 
    l = null;
    System.gc();
  }

  TypyTestu(Collection col) {
    this.col = col;
  }

  private void tisk() {
    if (DEBUG == true) {
      System.out.print(col + " ");
    }
  }

  private abstract class Akce {
    abstract void akce();
  }

  private Akce[] poleAkci = {
    // naplneni
    new Akce() {
      void akce() {
        for (int i = 0;  i < POCET_PRVKU;  i++) {
          col.add(pole[i]);
        }
        tisk();
      }
    },
    
    // vypusteni poloviny s vyhledavanim
    new Akce() {
      void akce() {
        for (int i = 0;  i < POCET_PRVKU;  i += 2) {
          col.remove(pole[i]);
        }
        tisk();
      }
    }
  };

  void testy() {
    for (int i = 0;  i < poleAkci.length;  i++) {
      long zac = System.currentTimeMillis();
      poleAkci[i].akce();
      long kon = System.currentTimeMillis();
      System.out.print((kon - zac) + ", ");
    }
    col.clear();
    col = null;
    System.gc();
  }
}

public class RychlostMnoziny {
  public static void main(String[] args) {
    char c = 'q';
    while (true) {
      System.out.println("q - quit, h - HashSet, t - TreeSet");
      try {
        byte[] pole = new byte[10];
        System.in.read(pole);
        c = Character.toLowerCase(new String(pole).trim().charAt(0));
      }
      catch (IOException e){
        e.printStackTrace();
      }
      if (c == 'q') 
        break;
      for (int i = 1; i < 10; i++) {
        System.out.print("" + i + ". ");
        TypyTestu.pripravaInicializacnihoPole();
        if (c == 'h') 
          new TypyTestu(new HashSet()).testy();
        if (c == 't') 
          new TypyTestu(new TreeSet()).testy();
        System.out.println();
      }   
      System.out.println();
    }
  }
}
